ResourcePath = "Homeopatix/MinstrelMentor/Resources/";

Images = {
	MinimizedIcon = ResourcePath .. "MinstrelMentor.tga",
};


function CreateLocalizationInfo()

	Strings = {};
	if Turbine.Engine.GetLanguage() == Turbine.Language.German then
		Strings.PluginName = "Minstrel Mentor";
		Strings.PluginText = "Par Homeopatix";
		Strings.PluginHelp = " *** Tierhandlung Hilfe ***\n\n/show show window\n/hide hide window\n\n\nSie k\195\182nnen Ihre Ges\195\164nge per Drag & Drop auf die Linien ziehen und mit dem Mausrad l\195\182schen";

elseif Turbine.Engine.GetLanguage() == 
Turbine.Language.French then
		Strings.PluginName = "Minstrel Mentor";
		Strings.PluginText = "Par Homeopatix";
		Strings.PluginHelp = " *** Minstrel Mentor Aide ***\n\n/show affiche la fenetre\n/hide cache la fenetre\n\n\nVous pouvez faire glisser et d\195\169poser vos chants sur les lignes et les effacer avec la molette de la souris";

elseif Turbine.Engine.GetLanguage() == 
Turbine.Language.English then
		Strings.PluginName = "Minstrel Mentor";
		Strings.PluginText = "Par Homeopatix";
		Strings.PluginHelp = " *** Pet Shop Help ***\n\n/show show window\n/hide hide window\n\nYou can drag and drop your songs on the lines and erase them with the mouse wheel";
	end
end