 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.MinstrelMentor.Globals"
 import "Homeopatix.MinstrelMentor.MinimizedIcon"
 import "Homeopatix.MinstrelMentor.VindarPatch"
 import "Homeopatix.MinstrelMentor.Commands"
 import "Homeopatix.MinstrelMentor.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Minstrel Mentor</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizey = tostring(settings.minimizey);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = tostring(settings.shortcutData_1);
   		settings.shortcutData_2 = tostring(settings.shortcutData_2);
   		settings.shortcutData_3 = tostring(settings.shortcutData_3);
   		settings.shortcutData_4 = tostring(settings.shortcutData_4);
   		settings.shortcutData_5 = tostring(settings.shortcutData_5);
   		settings.shortcutData_6 = tostring(settings.shortcutData_6);
   		settings.shortcutData_7 = tostring(settings.shortcutData_7);
   		settings.shortcutData_8 = tostring(settings.shortcutData_8);
   		settings.shortcutData_9 = tostring(settings.shortcutData_9);
   		settings.shortcutData_10 = tostring(settings.shortcutData_10);

   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "MinstrelMentor_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
MinstrelMentorWindow=Turbine.UI.Lotro.GoldWindow(); 
MinstrelMentorWindow:SetSize(210,170); 
MinstrelMentorWindow:SetText(Strings.PluginName); 

MinstrelMentorWindow.Message=Turbine.UI.Label(); 
MinstrelMentorWindow.Message:SetParent(MinstrelMentorWindow); 
MinstrelMentorWindow.Message:SetSize(150,10); 
MinstrelMentorWindow.Message:SetPosition(MinstrelMentorWindow:GetWidth()/2 - 75, MinstrelMentorWindow:GetHeight()/2 + 65); 
MinstrelMentorWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
MinstrelMentorWindow.Message:SetText(Strings.PluginText); 
MinstrelMentorWindow:SetWantsKeyEvents(true);
MinstrelMentorWindow:SetVisible(settings.isWindowVisible); 


function MinstrelMentorWindow:Closing(sender, args)
	settings.isWindowVisible = false;
end

MinstrelMentorWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( MinstrelMentorWindow );
centerWindow:SetPosition( 11 ,MinstrelMentorWindow:GetHeight()/2 - 32);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( MinstrelMentorWindow );
centerWindow2:SetPosition( 49 ,MinstrelMentorWindow:GetHeight()/2 - 32);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow3 = Turbine.UI.Extensions.SimpleWindow();
centerWindow3:SetSize( 36 , 36 );
centerWindow3:SetParent( MinstrelMentorWindow );
centerWindow3:SetPosition( 87 ,MinstrelMentorWindow:GetHeight()/2 - 32);
centerWindow3:SetVisible( true );
centerWindow3:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow4 = Turbine.UI.Extensions.SimpleWindow();
centerWindow4:SetSize( 36 , 36 );
centerWindow4:SetParent( MinstrelMentorWindow );
centerWindow4:SetPosition( 125 ,MinstrelMentorWindow:GetHeight()/2 - 32);
centerWindow4:SetVisible( true );
centerWindow4:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow5 = Turbine.UI.Extensions.SimpleWindow();
centerWindow5:SetSize( 36 , 36 );
centerWindow5:SetParent( MinstrelMentorWindow );
centerWindow5:SetPosition( 163 ,MinstrelMentorWindow:GetHeight()/2 - 32);
centerWindow5:SetVisible( true );
centerWindow5:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow6 = Turbine.UI.Extensions.SimpleWindow();
centerWindow6:SetSize( 36 , 36 );
centerWindow6:SetParent( MinstrelMentorWindow );
centerWindow6:SetPosition( 11 ,MinstrelMentorWindow:GetHeight()/2 + 12);
centerWindow6:SetVisible( true );
centerWindow6:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow7 = Turbine.UI.Extensions.SimpleWindow();
centerWindow7:SetSize( 36 , 36 );
centerWindow7:SetParent( MinstrelMentorWindow );
centerWindow7:SetPosition( 49 ,MinstrelMentorWindow:GetHeight()/2 + 12);
centerWindow7:SetVisible( true );
centerWindow7:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow8 = Turbine.UI.Extensions.SimpleWindow();
centerWindow8:SetSize( 36 , 36 );
centerWindow8:SetParent( MinstrelMentorWindow );
centerWindow8:SetPosition( 87 ,MinstrelMentorWindow:GetHeight()/2 + 12);
centerWindow8:SetVisible( true );
centerWindow8:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow9 = Turbine.UI.Extensions.SimpleWindow();
centerWindow9:SetSize( 36 , 36 );
centerWindow9:SetParent( MinstrelMentorWindow );
centerWindow9:SetPosition( 125 ,MinstrelMentorWindow:GetHeight()/2 + 12);
centerWindow9:SetVisible( true );
centerWindow9:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow10 = Turbine.UI.Extensions.SimpleWindow();
centerWindow10:SetSize( 36 , 36 );
centerWindow10:SetParent( MinstrelMentorWindow );
centerWindow10:SetPosition( 163 ,MinstrelMentorWindow:GetHeight()/2 + 12);
centerWindow10:SetVisible( true );
centerWindow10:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow3);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow4);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow5);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow6);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow7);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow8);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow9);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow10);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

centerQS3 = Turbine.UI.Lotro.Quickslot();
centerQS3:SetParent( centerWindow3 );
centerQS3:SetPosition( 0, 0 );
centerQS3:SetSize( 35, 35 );
centerQS3:SetUseOnRightClick(false);

centerQS4 = Turbine.UI.Lotro.Quickslot();
centerQS4:SetParent( centerWindow4 );
centerQS4:SetPosition( 0, 0 );
centerQS4:SetSize( 35, 35 );
centerQS4:SetUseOnRightClick(false);

centerQS5 = Turbine.UI.Lotro.Quickslot();
centerQS5:SetParent( centerWindow5 );
centerQS5:SetPosition( 0, 0 );
centerQS5:SetSize( 35, 35 );
centerQS5:SetUseOnRightClick(false);

centerQS6 = Turbine.UI.Lotro.Quickslot();
centerQS6:SetParent( centerWindow6 );
centerQS6:SetPosition( 0, 0 );
centerQS6:SetSize( 35, 35 );
centerQS6:SetUseOnRightClick(false);

centerQS7 = Turbine.UI.Lotro.Quickslot();
centerQS7:SetParent( centerWindow7 );
centerQS7:SetPosition( 0, 0 );
centerQS7:SetSize( 35, 35 );
centerQS7:SetUseOnRightClick(false);

centerQS8 = Turbine.UI.Lotro.Quickslot();
centerQS8:SetParent( centerWindow8 );
centerQS8:SetPosition( 0, 0 );
centerQS8:SetSize( 35, 35 );
centerQS8:SetUseOnRightClick(false);

centerQS9 = Turbine.UI.Lotro.Quickslot();
centerQS9:SetParent( centerWindow9 );
centerQS9:SetPosition( 0, 0 );
centerQS9:SetSize( 35, 35 );
centerQS9:SetUseOnRightClick(false);

centerQS10 = Turbine.UI.Lotro.Quickslot();
centerQS10:SetParent( centerWindow10 );
centerQS10:SetPosition( 0, 0 );
centerQS10:SetSize( 35, 35 );
centerQS10:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------

if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_1, settings.shortcutData_1 ) );
end
if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_2, settings.shortcutData_2 ) );
end
if(settings.shortcutData_3 ~= "") then
	centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_3, settings.shortcutData_3 ) );
end
if(settings.shortcutData_4 ~= "") then
	centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_4, settings.shortcutData_4 ) );
end
if(settings.shortcutData_5 ~= "") then
	centerQS5:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_5, settings.shortcutData_5 ) );
end
if(settings.shortcutData_6 ~= "") then
	centerQS6:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_6, settings.shortcutData_6 ) );
end
if(settings.shortcutData_7 ~= "") then
	centerQS7:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_7, settings.shortcutData_7 ) );
end
if(settings.shortcutData_8 ~= "") then
	centerQS8:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_8, settings.shortcutData_8 ) );
end
if(settings.shortcutData_9 ~= "") then
	centerQS9:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_9, settings.shortcutData_9 ) );
end
if(settings.shortcutData_10 ~= "") then
	centerQS10:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_10, settings.shortcutData_10 ) );
end

settings.shortcutData_1 = "0x7000C78B"; -- morceaux de fruit pourrit non theatre
settings.shortcutData_2 = "0x7000C787"; -- ptale de fleurs de rivegel
settings.shortcutData_3 = "0x7002B5AF"; -- morceaux de fruit pourri pour le theatre
settings.shortcutData_4 = "0x7000C788"; -- boule de neige parfaite pour l'instance
settings.shortcutData_5 = "0x7000C789"; -- boule de neige parfaite pour concours de boule de neige
settings.shortcutData_6 = ""; -- boule de neige parfaite pour concours de boule de neige
settings.shortcutData_7 = ""; -- boule de neige parfaite pour concours de boule de neige
settings.shortcutData_8 = ""; -- boule de neige parfaite pour concours de boule de neige
settings.shortcutData_9 = ""; -- boule de neige parfaite pour concours de boule de neige
settings.shortcutData_10 = ""; -- boule de neige parfaite pour concours de boule de neige
centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_1 ) );
centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_2 ) );
centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_3 ) );
centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_4 ) );
centerQS5:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_5 ) );
--centerQS6:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_6 ) );
--centerQS7:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_7 ) );
--centerQS8:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_8 ) );
--centerQS9:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_9 ) );
--centerQS10:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_10 ) );

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();
	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end

centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_2 = tmp;

	SaveSettings();
end

centerQS3.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS3:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_3 = tmp;

	SaveSettings();
end

centerQS4.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS4:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_4 = tmp;

	SaveSettings();
end

centerQS5.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS5:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_5 = tmp;

	SaveSettings();
end

centerQS6.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS6:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_6 = tmp;

	SaveSettings();
end

centerQS7.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS7:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_7 = tmp;

	SaveSettings();
end

centerQS8.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS8:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_8 = tmp;

	SaveSettings();
end

centerQS9.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS9:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_9 = tmp;

	SaveSettings();
end

centerQS10.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS10:GetShortcut();
	tmp = tmp:GetData();

	settings.shortcutData_10 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS3.MouseWheel = function(sender, args)
	settings.shortcutData_3 = tostring(""); 
	centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS4.MouseWheel = function(sender, args)
	settings.shortcutData_4 = tostring(""); 
	centerQS4:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS5.MouseWheel = function(sender, args)
	settings.shortcutData_5 = tostring(""); 
	centerQS5:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS6.MouseWheel = function(sender, args)
	settings.shortcutData_6 = tostring(""); 
	centerQS6:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS7.MouseWheel = function(sender, args)
	settings.shortcutData_7 = tostring(""); 
	centerQS7:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS8.MouseWheel = function(sender, args)
	settings.shortcutData_8 = tostring(""); 
	centerQS8:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS9.MouseWheel = function(sender, args)
	settings.shortcutData_9 = tostring(""); 
	centerQS9:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS10.MouseWheel = function(sender, args)
	settings.shortcutData_10 = tostring(""); 
	centerQS10:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, MinstrelMentorWindow:SetVisible(true));

MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
MinstrelMentorWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		MinstrelMentorWindow:SetVisible(false);
		settings.isWindowVisible = false;
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	MinstrelMentorWindow.PositionChanged = function( sender, args )
    	local x,y = MinstrelMentorWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



